/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  29.04.2015 [*] LookUpDocument:  .
  26.02.2015 [+] LookUpClient. LookUpTrademark.
  25.02.2015 [+] LookUpDocument.
             [+] LookUpModel.
  24.03.2012 [*]  ViewDevicePowerName, ViewWorkplacePowerName.
  21.03.2012 [*] LookupDeviceAtDepartment:   .
  22.02.2012 [+] LookupDeviceAtDepartment:    .
             [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scLookUp.sql,v 1.2 2015/04/29 03:26:12 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'LookUpDeviceAtDepartment'
EXECUTE CheckDropProcedure 'LookUpModel'
EXECUTE CheckDropProcedure 'LookUpDocument'
EXECUTE CheckDropProcedure 'LookUpTrademark'
EXECUTE CheckDropProcedure 'LookUpClient'
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookUpDeviceAtDepartment @CS INT, @R INT
AS
  DECLARE @DV INT
  IF (@R = 0) 
    SELECT @DV = CmplIdDevice FROM CompleteSet WHERE (IdComponent = @CS)
    ELSE SET @DV = @CS
  SELECT ViewDevicePowerName.ID, 
         NameNumber + ' (' + NameUser + ')' AS Name
    FROM ViewDevicePowerName
      INNER JOIN ViewWorkplacePowerName ON ViewDevicePowerName.High = ViewWorkplacePowerName.ID
    WHERE ViewWorkplacePowerName.Higher IN ( SELECT Wp.WrkpIdDepartment 
                                            FROM DeviceUnit AS Dv 
                                              INNER JOIN Workplace AS Wp ON Dv.DevcIdWorkplace = Wp.IdWorkplace 
                                            WHERE(dv.IdDevice = @DV))
    ORDER BY Name  
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookUpModel @KD INT
AS
  SELECT IdModel  AS ID, 
         ModlName AS Name, 
         DisplayParameters AS [Parameters]
    FROM Model
    WHERE (ModlKind = @KD)
    ORDER BY ModlWeight
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookUpDocument
AS
  SELECT [Document].IdDocument          AS ID, 
         ViewDocumentPowerName.NameFirm AS Name,
         [Document].DocDate             AS [Date]
    FROM [Document] 
      INNER JOIN ViewDocumentPowerName ON [Document].IdDocument = ViewDocumentPowerName.ID
    ORDER BY [Document].DocDate DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookUpTrademark
AS
  SELECT ID, Name, Ranking
    FROM Trademark
    ORDER BY Ranking DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookUpClient
AS
  SELECT ID, NameTrademark AS Name
    FROM FirmNamePower
    ORDER BY NameTrademark
--
GO
--=====================================================================================================================
-- :
---- Kind
-- 107 = CPU Core:  Intel Core
---- Document:
-- 865 =   16587398  27.01.2015; ULMart,  " "
--
--EXECUTE LookUpDeviceAtDepartment 1255, 1
--EXECUTE LookUpModel 107
EXECUTE LookUpDocument
--EXECUTE LookUpTrademark
--EXECUTE LookUpClient
