/*=====================================================================================================================

   " ".

    . .

=======================================================================================================================

  :

  07.06.2013 [+] ,  , , .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scDocumentReport.sql,v 1.1 2013/06/07 13:41:18 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'ReportDocument'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportDocument @DOC INT
AS
  DECLARE @MX INT
  SELECT @MX = MAX(DocumentPosition) FROM CompleteSet WHERE (DocumentId = @DOC)
  SELECT ViewDocumentPowerName.NameFirm AS NameDocument, 
         CompleteSet.DocumentPosition, 
         ViewModelPowerName.NameKind AS ModelName, 
         CompleteSet.DisplayNumber AS Number, 
         ISNULL(CompleteSet.Price, 0) AS Price, 
         ViewDevicePowerName.NameNumber AS DeviceName, 
         ViewWorkplacePowerName.NameUserDepartment
    FROM [Document] 
      INNER JOIN ViewDocumentPowerName ON [Document].IdDocument = ViewDocumentPowerName.ID 
      INNER JOIN CompleteSet ON [Document].IdDocument = CompleteSet.DocumentId 
      INNER JOIN ViewModelPowerName ON CompleteSet.CmplIdModel = ViewModelPowerName.ID 
      INNER JOIN ViewDevicePowerName ON CompleteSet.CmplIdDevice = ViewDevicePowerName.ID 
      INNER JOIN ViewWorkplacePowerName ON ViewDevicePowerName.High = ViewWorkplacePowerName.ID
    WHERE ([Document].IdDocument = @DOC)
  --
  UNION
  --
    SELECT ViewDocumentPowerName.NameFirm, number + 1, NULL , NULL, NULL, NULL, '<   >'
      FROM master.dbo.spt_values
      CROSS JOIN ViewDocumentPowerName
        WHERE (ViewDocumentPowerName.ID = @DOC) AND ( type = 'P' ) AND ( number < @MX )
              AND ((number + 1) NOT IN (SELECT DocumentPosition FROM CompleteSet WHERE (DocumentId = @DOC)))

  --
  ORDER BY 1, 6, 2



--
GO
--=====================================================================================================================
-- 
-- 806 =    238373  29.03.2013; Flash
--
EXECUTE ReportDocument 806

