{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  04.03.2015 [*]   .
  25.02.2015 [*]  DBNavigator  .
             [-] TPropStorageEh.
  12.03.2012 [!]  .
             [*]  .
             [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]   Windows 7.
  26.03.2007 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgDocumentList.pas,v 1.6 2015/03/08 05:02:35 tsk Exp $
=======================================================================================================================}
unit dgDocumentList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DB, ADODB, StdCtrls, Mask, DBCtrls,
      Buttons, Grids, DBGridEh, ExtCtrls, DBGridEhGrouping, GridsEh, DBCtrlsEh, DBLookupEh, ComCtrls, ToolCtrlsEh,
      DBGridEhToolCtrls, DynVarsEh, DBAxisGridsEh,
      // Comming:
      CommingDateTime, CommingDialog, CommingADO,
      // ComputerWare:
      dgBaseList, dmCommingData, dgDocumentEdit;

type
  TDocumentListDG = class(TBASEListDG)
    taDoc: TADODataSet;
    taDocDocDate: TDateTimeField;
    taDocDocName: TStringField;
    taDocClientName: TStringField;
    edDateFind: TDateTimePicker;
    Label1: TLabel;
    taDocID: TAutoIncField;
    taDocSum: TBCDField;
    procedure btBackClick(Sender: TObject);
    procedure edDateFindChange(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private   { Private declarations }
    procedure RefreshDoc( ID: Integer = CURRENT_RECORD );
  public    { Public declarations }
    function   Run( Back: TField ): Boolean;
  end;

var  DocumentListDG: TDocumentListDG;

implementation
{$R *.DFM}
//======================================================================================================================
{ TDocumentListDG }
//======================================================================================================================
function TDocumentListDG.Run( Back: TField ): Boolean;
begin
  if DocumentListDG = nil then Application.CreateForm(TDocumentListDG, DocumentListDG);
  with DocumentListDG do begin
    RequeryParameters( taDoc, []);
    Field := Back;
    taDoc.Locate( 'ID', Back.AsInteger, [] );
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TDocumentListDG.edDateFindChange(Sender: TObject);
begin
  taDoc.DisableControls;
  if taDocDocDate.Value < edDateFind.DateTime then taDoc.First;
  while taDocDocDate.Value > edDateFind.DateTime do taDoc.Next;
  taDoc.EnableControls;
end;
//======================================================================================================================
procedure TDocumentListDG.RefreshDoc(ID: Integer);
begin
  Screen.Cursor := crHourGlass;
  if ID = CURRENT_RECORD then ID := taDocID.Value;
  RequeryParameters( taDoc, []);
  taDoc.Locate( 'ID', ID, []);
  Screen.Cursor := crHourGlass;
end;
//======================================================================================================================
procedure TDocumentListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if DocumentEditDG.Run( INSERT_DATA ) then RefreshDoc( DocumentEditDG.taDataIdDocument.AsInteger );
end;
//======================================================================================================================
procedure TDocumentListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if DocumentEditDG.Run( taDocID.Value ) then RefreshDoc( DocumentEditDG.taDataIdDocument.AsInteger );
end;
//======================================================================================================================
procedure TDocumentListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowAskDelete( taDocDocName.AsString ) then begin
    DeleteRecord( 'Document', taDocID, 'IdDocument' );
    taDoc.Next;
    RefreshDoc( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
procedure TDocumentListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taDocID.Value );
end;
//======================================================================================================================
end.
