/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  26.02.2015 [+] ClientList:  .
  25.02.2015 [*] FirmNamePower:   .
  14.02.2015 [+] FirmNamePower:    ,  .
             [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scFirm.sql,v 1.1 2015/03/08 05:02:37 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropView     'FirmNamePower'
EXECUTE CheckDropView		  'ClientList'
EXECUTE CheckDropTrigger  'TrademarkClientUpdate'
EXECUTE CheckDropTrigger  'TrademarkClientDelete'
--
GO
--=====================================================================================================================
CREATE VIEW FirmNamePower
AS
  SELECT Client.IdClient AS ID, 
         ISNULL(Trademark.Name + ', ', '') + Client.ClntNameFull AS NameTrademark, 
         ISNULL(Trademark.Ranking, 0) AS Ranking
    FROM Trademark 
      RIGHT OUTER JOIN Client ON Trademark.ID = Client.Trademark
--
GO
--=====================================================================================================================
CREATE VIEW ClientList
AS
  SELECT Client.IdClient                                    AS ID, 
         ISNULL(Trademark.Name + '', Client.ClntNameShort) AS TradeName, 
         Client.ClntNameFull                                AS ClientName, 
         Client.CountDoc, 
         Client.CountModel
    FROM Client 
      LEFT OUTER JOIN Trademark ON Client.Trademark = Trademark.ID
--
GO
--=====================================================================================================================
CREATE TRIGGER TrademarkClientUpdate ON Client FOR INSERT, UPDATE
AS
  UPDATE Trademark SET Ranking = (SELECT COUNT(*) FROM Client AS CL WHERE (CL.Trademark = inserted.Trademark))
    FROM Trademark INNER JOIN inserted ON Trademark.ID = inserted.Trademark
--
GO
--=====================================================================================================================
CREATE TRIGGER TrademarkClientDelete ON Client FOR DELETE
AS
  UPDATE Trademark SET Ranking = (SELECT COUNT(*) FROM Client AS CL WHERE (CL.Trademark = deleted.Trademark))
    FROM Trademark INNER JOIN deleted ON Trademark.ID = deleted.Trademark
--
GO
--=====================================================================================================================
-- 297 = Zenon; 
-- :
--SELECT * FROM FirmNamePower ORDER BY 3 DESC
SELECT * FROM ClientList ORDER BY 3
