{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  08.03.2015 [+] .
             [*]  .
  03.03.2015 [+] , .
             [+]  (  ).
             [+] .
             [+] .
             [+] SetKindCombo:  .
  22.02.2015 [-] TPropStorageEh.
  19.02.2015 [*] Unicode.
  10.03.2012 [*] RefreshKind:   .
  09.03.2012 [*]     .
             [+]       dmComming.SetCommingValue.
             [*] 
             [-]  .
             [*]   .
             [*]    .
  24.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]   Windows 7.
  03.04.2007 [*]    .
  13.02.2007 [*]      XP.
  16.11.2001 [*]  .
  14.11.2001 [*]   TBASEListDG.
             [*]  .
  13.11.2001 [*]  -
  12.11.2001 [*]      .
  09.11.2001 [*]    .
             [+]     RecordExchangeMoving.
             [*]  .
  08.11.2001 [+]  Comming.
             [*]    .
             [-]  TAB.
  06.11.2001 [*]   MS SQL Server 2000  ODBC   TDataSet.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgKindList.pas,v 1.2 2015/03/08 09:03:46 tsk Exp $
=======================================================================================================================}
unit dgKindList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Db, Grids, DBGrids, ExtCtrls, DBCtrls,
      ComCtrls, StdCtrls, Buttons, DBGridEh, ADODB, Variants, DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls,
      DynVarsEh, DBAxisGridsEh,
      // Base, Comming & ComputerWare:
      dgBaseList, CommingADO, CommingDialog, dmCommingData, dgKindEdit;

type
  TKindListDG = class(TBASEListDG)
    cbType: TComboBox;
    btUp: TSpeedButton;
    btDown: TSpeedButton;
    taKind: TADODataSet;
    taKindIdKind: TSmallintField;
    taKindKindType: TStringField;
    taKindKindOrder: TIntegerField;
    taKindKindName: TStringField;
    taKindKindImage: TSmallintField;
    taKindShortName: TStringField;
    spMove: TADOStoredProc;
    taKindUsesModel: TIntegerField;
    taKindUsesDevice: TIntegerField;
    procedure cbTypeChange(Sender: TObject);
    procedure btUpClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure btBackClick(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure dsListDataChange(Sender: TObject; Field: TField);
    procedure btDeleteClick(Sender: TObject);
    procedure btFindClick(Sender: TObject);
  private   { Private declarations }
    function  GetKindCombo: String;
    procedure SetKindCombo( KindType: String );
    procedure RefreshKind( ID: Integer );
  public    { Public declarations }
    function Run ( ID: Integer = SAVE_RECORD; Back: TField = nil; Kind: String = '*' ): Boolean;
  end;

var KindListDG: TKindListDG;

implementation

{$R *.DFM}

uses dmChainData, dgKindFind;
//======================================================================================================================
{ TKindListDG }
//======================================================================================================================
function TKindListDG.Run( ID: Integer; Back: TField; Kind: String ): Boolean;
begin
  if KindListDG = nil then Application.CreateForm( TKindListDG, KindListDG );
  with KindListDG do begin
    if ID = SAVE_RECORD then ID := Tag;
    dmChain.Kind := ID;
    SetKindCombo( dmChain.KindType );
    RefreshKind( ID );
    Field := Back;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TKindListDG.dsListDataChange(Sender: TObject; Field: TField);
begin
//  inherited;
  btDelete.Enabled := (( taKindUsesModel.Value + taKindUsesDevice.Value ) = 0 );
end;
//======================================================================================================================
function TKindListDG.GetKindCombo: String;
begin
  Result := Copy( cbType.Text, 1, 1 )
end;
//======================================================================================================================
procedure TKindListDG.SetKindCombo( KindType: String );
begin
  cbType.ItemIndex := Pos( KindType, 'DHMS') - 1;
end;
//======================================================================================================================
procedure TKindListDG.RefreshKind( ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  if (ID = CURRENT_RECORD) then ID := taKindIdKind.Value;
  RequeryParameters( taKind, [ GetKindCombo ]);
  taKind.Locate( 'IdKind', ID, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TKindListDG.cbTypeChange(Sender: TObject);
begin
  RefreshKind( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TKindListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if KindEditDG.Run( INSERT_DATA, GetKindCombo ) then begin
    SetKindCombo( KindEditDG.taDataKindType.AsString);
    RefreshKind( KindEditDG.taDataIdKind.Value );
  end;
end;
//======================================================================================================================
procedure TKindListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if KindEditDG.Run( taKindIdKind.Value, GetKindCombo ) then begin
    SetKindCombo( KindEditDG.taDataKindType.AsString);
    RefreshKind( KindEditDG.taDataIdKind.Value );
  end;
end;
//======================================================================================================================
procedure TKindListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowAskDelete( taKindKindName.AsString ) then begin
    DeleteRecord( 'Kind', taKindIdKind );
    taKind.Prior;
    RefreshKind( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
procedure TKindListDG.btFindClick(Sender: TObject);
begin
//  inherited;
  if KindFindDG.Run then begin
//    Visual := False;
    SetKindCombo( KindFindDG.taFindKindType.AsString);
    RefreshKind( KindFindDG.taFindID.Value );
//    Visual := True;
  end;
end;
//======================================================================================================================
procedure TKindListDG.btUpClick(Sender: TObject);
begin
  spMove.Parameters[1].Value := taKindIdKind.Value;
  spMove.Parameters[2].Value := -1;
  spMove.ExecProc;
  RefreshKind( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TKindListDG.btDownClick(Sender: TObject);
begin
  spMove.Parameters[1].Value := taKindIdKind.Value;
  spMove.Parameters[2].Value := 1;
  spMove.ExecProc;
  RefreshKind( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TKindListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taKindIdKind.Value );
end;
//======================================================================================================================
end.
