{=======================================================================================================================

   " ".

    , .

========================================================================================================================

  :

  16.11.2015 [+]     .
  14.02.2015 [+]    "".
             [+]    "".
             [+]   .
             [*]       ( 8).
  10.03.2012 [*]  .
             [-]  uses
  21.02.2012 [*] .
  19.02.2012 [*]   .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]   Windows 7.
  30.03.2011 [*]    .
  04.08.2009 [+]     btExit.
  18.06.2008 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmSearch.pas,v 1.7 2015/11/16 02:18:13 tsk Exp $
=======================================================================================================================}
unit fmSearch;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBGridEh, ADODB,
      ToolWin, ComCtrls, DB, DBCtrls, Grids, ExtCtrls, Buttons, ActnList, PropFilerEh, PropStorageEh, ImgList,
      DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, System.Actions, DBAxisGridsEh, Vcl.Clipbrd,
      // Comming:
      CommingDisplay, CommingADO,
      // ComputerWare:
      dmCommingData;

type
  TSearchFM = class(TForm)
    grSearch: TDBGridEh;
    dsSearch: TDataSource;
    taSearch: TADODataSet;
    tbDoc: TToolBar;
    alDoc: TActionList;
    acFind: TAction;
    stMain: TPropStorageEh;
    ToolButton6: TToolButton;
    ToolButton5: TToolButton;
    acGoTree: TAction;
    ToolButton9: TToolButton;
    taSearchKind: TStringField;
    taSearchID: TIntegerField;
    taSearchName: TStringField;
    imKind: TImageList;
    cbFind: TComboBox;
    acGoModel: TAction;
    taSearchModel: TIntegerField;
    ToolButton1: TToolButton;
    acGoDocument: TAction;
    ToolButton2: TToolButton;
    taSearchDocument: TIntegerField;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    acPastFind: TAction;
    procedure acGoTreeUpdate(Sender: TObject);
    procedure acGoTreeExecute(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure grSearchDrawColumnCell(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumnEh; State: TGridDrawState);
    procedure acFindUpdate(Sender: TObject);
    procedure cbFindChange(Sender: TObject);
    procedure acGoModelExecute(Sender: TObject);
    procedure acGoModelUpdate(Sender: TObject);
    procedure acGoDocumentUpdate(Sender: TObject);
    procedure acGoDocumentExecute(Sender: TObject);
    procedure acPastFindExecute(Sender: TObject);
    procedure acPastFindUpdate(Sender: TObject);
  private   { Private declarations }
    procedure SaveFind;
  public    { Public declarations }
  end;

var  SearchFM: TSearchFM;

implementation

uses fmLayout, fmMain, fmModelList, fmDocumentList;

{$R *.DFM}
//======================================================================================================================
{ TSearchFM }
//======================================================================================================================
procedure TSearchFM.grSearchDrawColumnCell(Sender: TObject; const Rect: TRect;
                                           DataCol: Integer; Column: TColumnEh; State: TGridDrawState);
  var S, B, E: String;
      p, l: Integer;
begin
  if DataCol = 1 then with grSearch.Canvas do begin
    S := AnsiUpperCase( Trim( cbFind.Text ));
    p := Pos( S, AnsiUpperCase( taSearchName.AsString ));
    B := Copy( taSearchName.AsString, 1, p - 1 );
    S := Copy( taSearchName.AsString, p, Length( S ) );
    E := Copy( taSearchName.AsString, p + Length( S ), taSearchName.Size );
    FillRect( Rect );
    l := 4;
    DrawCellTextOut( grSearch.Canvas, Rect, l, B );
    Inc( l, 1 );
    Font.Style := [fsBold];
    DrawCellTextOut( grSearch.Canvas, Rect, l, S + '' );
    Inc( l, 1 );
    Font.Style := [];
    DrawCellTextOut( grSearch.Canvas, Rect, l, E );
  end;
end;
//======================================================================================================================
procedure TSearchFM.cbFindChange(Sender: TObject);
begin
  taSearch.Close;
end;
//======================================================================================================================
procedure TSearchFM.SaveFind;
begin
  if cbFind.Items.IndexOf( Trim( cbFind.Text )) < 0 then cbFind.Items.Add( Trim( cbFind.Text ));
  while cbFind.Items.Count > cbFind.DropDownCount do cbFind.Items.Delete( 0 );
end;
//======================================================================================================================
procedure TSearchFM.acFindUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( Length( Trim( cbFind.Text )) > 1 );
end;
//======================================================================================================================
procedure TSearchFM.acFindExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  RequeryParameters( taSearch, [ Trim( cbFind.Text )]);
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TSearchFM.acPastFindUpdate(Sender: TObject);
begin
  try
    TAction(Sender).Enabled := not ( Clipboard.AsText = EmptyStr);
  except
    TAction(Sender).Enabled := False;
  end;
end;
//======================================================================================================================
procedure TSearchFM.acPastFindExecute(Sender: TObject);
begin
  cbFind.Text := Clipboard.AsText;
end;
//======================================================================================================================
procedure TSearchFM.acGoTreeUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSearch.Active ) and ( taSearch.RecordCount > 0 );
end;
//======================================================================================================================
procedure TSearchFM.acGoTreeExecute(Sender: TObject);
begin
  SaveFind;
  MainFM.pcMain.ActivePage := MainFM.tsLayout;
  LayoutMainFM.FindAny( taSearchKind.AsString, taSearchID.Value );
end;
//======================================================================================================================
procedure TSearchFM.acGoModelUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSearch.Active ) and ( taSearch.RecordCount > 0 ) and ( not taSearchModel.IsNull );
end;
//======================================================================================================================
procedure TSearchFM.acGoModelExecute(Sender: TObject);
begin
  SaveFind;
  MainFM.pcMain.ActivePage := MainFM.tsModel;
  ModelListFM.RefreshComponent( taSearchID.Value );
end;
//======================================================================================================================
procedure TSearchFM.acGoDocumentUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSearch.Active ) and ( taSearch.RecordCount > 0 ) and ( not taSearchDocument.IsNull );
end;
//======================================================================================================================
procedure TSearchFM.acGoDocumentExecute(Sender: TObject);
begin
  SaveFind;
  MainFM.pcMain.ActivePage := MainFM.tsDocument;
  DocumentListFM.RefreshComponent( taSearchID.Value );
end;
//======================================================================================================================
end.








