/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  23.02.2015 [+] GridSearch:  ,  .
  31.07.2012 [*] GridSearch:    ViewWorkplacePowerName. 
             [*] GridSearch:    .
  15.12.2010 [*] GridSearch:  .
  18.06.2008 [+] GridSearch:   ,  , , .
             [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scSearch.sql,v 1.5 2015/03/11 13:34:27 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'GridSearch'
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridSearch @P VARCHAR(250)
AS
  SET @P = '%' + @P + '%'
  SELECT 'D'                            AS Kind,
         IdDepartment                   AS ID, 
         CAST(DprtName AS VARCHAR(500)) AS Name,
         CAST(NULL AS INT)              AS Model,
         CAST(NULL AS INT)              AS Document
    FROM Department
    WHERE (DprtName + ' ' + Synonym LIKE @P)
  --
  UNION
  --
  SELECT 'W',
         ID,
         NameUserDepartment,
         NULL,
         NULL
    FROM ViewWorkplacePowerName
      WHERE (NameFind LIKE @P)
  --
  UNION
  --
  SELECT 'V',
         ID, 
         NameNumber,
         NULL,
         NULL
    FROM ViewDevicePowerName
    WHERE ( NameFind LIKE @P)
  --
  UNION
  --
  SELECT Kind.KindType,
         CompleteSet.IdComponent, 
         Model.DisplayName + '. S/N:' + CompleteSet.DisplayNumber,
         CompleteSet.CmplIdModel,
         CompleteSet.DocumentId
    FROM CompleteSet 
      INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind
    WHERE (Model.DisplayName + ' ' + CompleteSet.DisplayNumber LIKE @P)
  --
  ORDER BY 3
--
GO
--=====================================================================================================================
-- 
EXECUTE GridSearch 'BT58'
